	name	c0s

_TEXT		segment	BYTE	PUBLIC	'CODE'
_TEXT		ends
_INIT_		segment	WORD	PUBLIC	'INITDATA'
InitStart	label	byte
_INIT_		ends
_INITEND_	segment	WORD	PUBLIC	'INITDATA'
InitEnd	label	byte
_INITEND_	ends
_EXIT_		segment	WORD	PUBLIC	'EXITDATA'
ExitStart	label	byte
_EXIT_		ends
_EXITEND_	segment	WORD	PUBLIC	'EXITDATA'
ExitEnd	label	byte
_EXITEND_	ends
_DATA		segment	PARA	PUBLIC	'DATA'
_DATA		ends
_CVTSEG		segment	WORD	PUBLIC	'DATA'
	public	__RealCvtVector
__RealCvtVector	label	dword
_CVTSEG		ends
_CRTSEG		segment	WORD	PUBLIC	'DATA'
_CRTSEG		ends
_SCNSEG		segment	WORD	PUBLIC	'DATA'
	public	__ScanTodVector
__ScanTodVector	label	dword
_SCNSEG		ends
_BSS		segment	WORD	PUBLIC	'BSS'
_BSS		ends
_BSSEND		segment	BYTE	PUBLIC	'ENDBSS'
enddata		label	byte
_BSSEND		ends
_STACK		segment	STACK	'STACK'
_STACK		ends

DGROUP	GROUP	_DATA,_CVTSEG,_CRTSEG,_SCNSEG,_BSS,_BSSEND
CGROUP	GROUP	_TEXT,_INIT_,_INITEND_,_EXIT_,_EXITEND_

_TEXT	segment

	ASSUME	CS:CGROUP,DS:DGROUP

	extrn	_main:near
	extrn	_c_service2:far
	public	_abort
	public	__exit
	public	__ExitClean
	public	_ActivateFloat
	public	_DeactivateFloat
	public	DGROUP@

Start	proc	near
		call	_ActivateFloat
		jmp	_main
Start	endp

__ExitClean	proc	near
__ExitClean	endp

__exit		proc	near
__exit		endp

_abort	proc	near
		mov	ax,ss
		mov	ds,ax
		mov	es,ax
		call	_DeactivateFloat
		mov	ax,17922		;m_fini
		push	ax
		call	far ptr _c_service2
_abort		endp

_ActivateFloat	proc	near
		call	SaveVector
		call	FloatInit
		ret
_ActivateFloat	endp

_DeactivateFloat	proc	near
		call	FloatFinish
		call	RestoreVector
		ret
_DeactivateFloat	endp

SaveVector	proc	near
		push	ds

		mov	ax,3500h
		int	21h
		mov	word ptr _Int0Vector,bx
		mov	word ptr _Int0Vector+2,es

		mov	ax,3504h
		int	21h
		mov	word ptr _Int4Vector,bx
		mov	word ptr _Int4Vector+2,	es

		mov	ax,3505h
		int	21h
		mov	word ptr _Int5Vector,bx
		mov	word ptr _Int5Vector+2,es

		mov	ax,3506h
		int	21h
		mov	word ptr _Int6Vector,bx
		mov	word ptr _Int6Vector+2,es

		mov	ax,2500h
		mov	dx,cs
		mov	ds,dx
		mov	dx,offset _abort
		int	21h

		pop	ds
		ret
SaveVector	ENDP

RestoreVector	proc	near
		push	ds
		mov	ax,2500h
		lds	dx,_Int0Vector
		int	21h
		pop	ds

		push	ds
		mov	ax,2504h
		lds	dx,_Int4Vector
		int	21h
		pop	ds

		push	ds
		mov	ax,2505h
		lds	dx,_Int5Vector
		int	21h
		pop	ds

		push	ds
		mov	ax,2506h
		lds	dx,_Int6Vector
		int	21h
		pop	ds
		ret
RestoreVector	endp

FloatInit	proc	near
		push	si
		push	di
		push	ds
		push	es
		mov	ax,ds
		mov	cs:DGROUP@,ax
		mov	word ptr __psp,ax
		mov	byte ptr cs:Dynamic,77h
		mov	byte ptr cs:InitSub+1,0ffh
		mov	al,LoadFlag
		or	al,al
		jz	FirstLoad
		mov	ax,cs
		mov	es,ax
		mov	si,offset DGROUP:InitSaveBuf
		mov	di,offset CGROUP:InitStart
RestCodeLoop:	mov	al,[si]
		mov	es:[di],al
		inc	si
		add	di,6
		cmp	di,offset CGROUP:InitEnd
		jnz	RestCodeLoop
		jmp	BeginInit

FirstLoad:	mov	byte ptr LoadFlag,1
		mov	ax,cs
		mov	es,ax
		mov	si,offset CGROUP:InitStart
		mov	di,offset DGROUP:InitSaveBuf
SaveCodeLoop:	mov	al,es:[si]
		mov	[di],al
		add	si,6
		inc	di
		cmp	si,offset CGROUP:InitEnd
		jnz	SaveCodeLoop
		mov	si,offset CGROUP:ExitStart
		mov	di,offset DGROUP:FinishSaveBuf
SaveCodeLoopF:	mov	al,es:[si]
		mov	[di],al
		add	si,6
		inc	di
		cmp	si,offset CGROUP:ExitEnd
		jnz	SaveCodeLoopF

BeginInit:	mov	ax,cs
		mov	ds,ax
		mov	si,offset CGROUP:InitStart
		mov	di,offset CGROUP:InitEnd
		call	InitSub
		pop	es
		pop	ds
		pop	di
		pop	si
		ret
FloatInit	endp

FloatFinish	proc	near
		push	si
		push	di
		push	ds
		mov	ax,ds
		mov	word ptr __psp,ax
		mov	cs:DGROUP@,ax
		mov	byte ptr cs:Dynamic,72h
		mov	byte ptr cs:InitSub+1,0
		mov	al,LoadFlag
		or	al,al
		jz	FinishStart
		mov	ax,cs
		mov	es,ax
		mov	si,offset DGROUP:FinishSaveBuf
		mov	di,offset CGROUP:ExitStart
RestCodeLoopF:	mov	al,[si]
		mov	es:[di],al
		inc	si
		add	di,6
		cmp	di,offset CGROUP:ExitEnd
		jnz	RestCodeLoopF
FinishStart:	mov	ax,cs
		mov	ds,ax
		mov	si,offset CGROUP:InitStart
		mov	di,offset CGROUP:InitEnd
		mov	ax,cs
		mov	ds,ax
		mov	si,offset CGROUP:ExitStart
		mov	di,offset CGROUP:ExitEnd
		call	InitSub
		pop	ds
		pop	di
		pop	si
		ret
FloatFinish	endp

InitSub		proc	near
InitLoop:	mov	ah,0ffh
		mov	dx,di
		mov	bx,si
ScanStart:	cmp	bx,di
		je	ScanEnd
		cmp	byte ptr [bx],0ffh
		je	NextTbl
		cmp	[bx+1],ah
Dynamic:	ja	NextTbl
		mov	ah,[bx+1]
		mov	dx,bx
NextTbl:	add	bx,6
		jmp	ScanStart

ScanEnd:	cmp	dx,di
		je	AllDone
		mov	bx,dx
		push	ds
		pop	es
		push	es
		cmp	byte ptr [bx],0
		mov	byte ptr [bx],0ffh
		push	ss
		pop	ds
		je	NearCall
		call	dword ptr es:[bx+2]
		pop	ds
		jmp	InitLoop

NearCall:	call	word ptr es:[bx+2]
		pop	ds
		jmp	InitLoop

AllDone:	ret
InitSub		endp

DGROUP@		dw	_TEXT

_TEXT		ends

_DATA		segment

	public	errno
	public	_errno
	public	___brklvl
	public	__psp

		db	2ch dup (0)
__psp		dw	_DATA
errno		dw	0
_errno		dw	0
___brklvl	dw	DGROUP:enddata
		dw	_DATA

_Int0Vector	dd	0
_Int4Vector	dd	0
_Int5Vector	dd	0
_Int6Vector	dd	0
LoadFlag	db	0
InitSaveBuf	db	16 dup (?)
FinishSaveBuf	db	16 dup (?)

_DATA		ends

_STACK		segment
		align	2
		db	4096 dup (?)
_STACK		ends

		end	Start
